//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <atl\atlvcl.h>

#include "SampleObjectImpl.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

STDMETHODIMP TSampleObjectImpl::get_NumericValue(long* Value)
{
  try
  {
    *Value = intdata;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_ISampleObject);
  }
  return S_OK;
};
//---------------------------------------------------------------------------

STDMETHODIMP TSampleObjectImpl::get_StringValue(BSTR* Value)
{
  try
  {
    if ((static_cast<BSTR>(strdata)) != 0)
        *Value = strdata;
    else
        throw Exception("StringValue has not been initialized !");
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_ISampleObject);
  }
  return S_OK;
};
//---------------------------------------------------------------------------

STDMETHODIMP TSampleObjectImpl::set_NumericValue(long Value)
{
  try
  {
    intdata = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_ISampleObject);
  }
  return S_OK;
};
//---------------------------------------------------------------------------

STDMETHODIMP TSampleObjectImpl::set_StringValue(BSTR Value)
{
  try
  {
     strdata = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_ISampleObject);
  }
  return S_OK;
};
//---------------------------------------------------------------------------

STDMETHODIMP TSampleObjectImpl::ShowProperties()
{
  try
  {
    char buf[128];
    wsprintf(buf, "The values are: intdata=%ld \n\t strdata=%ls",intdata,strdata.c_bstr());
    MessageBox(NULL, buf, "SimpleServer::ShowProperties", MB_OK);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_ISampleObject);
  }
  return S_OK;
};
//---------------------------------------------------------------------------

